class Block(object):
	def getblocksize(self):
		return self.__blocksize
	blocksize = property(getblocksize, None, None, 'blocksize')

	def getoffset(self):
		return self.__offset
	offset = property(getoffset, None, None, 'offset')

	def __init__(self, fh, blocksize=512, offset=0, length=None):
		try:
			fd = int(fh)
			fh = os.fdopen(fd)
		except (ValueError, TypeError):
			pass

		self.fh = fh
		if length == None:
			fh.seek(0, 2)
			self.fhlen = fh.tell()
		else:
			self.fhlen = length

		self.__blocksize = blocksize
		if self.fhlen % self.blocksize != 0:
			raise TypeError, 'fh must be evenly divisable by blocksize'
		self.__offset = offset
		if self.offset < 0 or self.offset >= len(self):
			raise ValueError, 'offset must be >= 0 and < length'

	def __len__(self):
		return self.fhlen / self.blocksize

	def __getitem__(self, key):
		return self.getlen(key, self.blocksize)

	def __setitem__(self, key, value):
		key = int(key) + self.offset
		assert key < len(self)
		value = str(value)
		assert len(value) == self.blocksize
		self.fh.seek(key * self.blocksize)
		return self.fh.write(self.blocksize, value)

	def __delitem__(self, key):
		raise TypeError, 'cannot delete items'

	def getlen(self, blk, l):
		assert l % self.blocksize == 0
		blk = int(blk) + self.offset
		if blk >= len(self):
			raise IndexError, "value out of range"

		self.fh.seek(blk * self.blocksize)
		return self.fh.read(l)

if __name__ == '__main__':
	foo = block(5)
